package ffp_examples;

/*
 *  clip.java
 *  This program demonstrates arbitrary clipping planes.
 */
public class clip extends DemoBase {

	public static void main(String[] args) {
		new clip().init(EUT_RGB);
	}

	public static void reshape(int w, int h) {
		ffp.ffpViewport(0, 0, w, h);
		create_projection(w, h);
	}

	private static void create_projection(int w, int h) {
		ffp.ffpMatrixMode(FFP_PROJECTION);
		ffp.ffpLoadIdentity();
		aux.auxPerspective(60.0f, (float) w / (float) h, 1.0f, 20.0f);
		ffp.ffpMatrixMode(FFP_MODELVIEW);
	}

	@Override
	public void dbInit(int width, int height) {
		reshape(width, height);
		ffp.ffpClearColor(0, 0, 0);
		ffp.ffpShadeModel(FFP_FLAT);
	}

	@Override
	public void dbUpdate() {

	}

	@Override
	public void dbRender() {
		float eqn[] = { 0.0f, 1.0f, 0.0f, 0.0f };
		float eqn2[] = { 1.0f, 0.0f, 0.0f, 0.0f };

		ffp.ffpClear(FFP_VIDEO_BUFFER | FFP_DEPTH_BUFFER);

		ffp.ffpColor3f(1.0f, 1.0f, 1.0f);
		ffp.ffpPushMatrix();
		ffp.ffpTranslatef(0.0f, 0.0f, -5.0f);

		//    clip lower half -- y < 0
		ffp.ffpClipPlane(FFP_CLIP_PLANE0, eqn);
		ffp.ffpEnable(FFP_CLIP_PLANE0);
		//    clip left half -- x < 0
		ffp.ffpClipPlane(FFP_CLIP_PLANE1, eqn2);
		ffp.ffpEnable(FFP_CLIP_PLANE1);

		ffp.ffpRotatef(90.0f, 1.0f, 0.0f, 0.0f);
		aux.auxWireSphere(1.0f, 20, 16);
		ffp.ffpPopMatrix();

		ffp.ffpFlush(FFP_MULTI_THREADED);
	}

}
