package ffp_examples;

/*
 * gamma.java
 * Draw test patterns to help determine correct gamma value for a display.
 * When the intensities in the top row nearly match the intensities in
 * the bottom row you've found the right gamma value.
 */
public class gamma extends DemoBase {

	public static void main(String[] args) {
		new gamma().init(EUT_RGB | EUT_NOT_RESIZABLE);
	}

	static short p25[] = { //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x00, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x00, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x00, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x00, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x00, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x00, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x00, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x00, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x00, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x00, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x00, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x00, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x00, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x00, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x00, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x00, 0x00, 0x00, 0x00, //n
	};

	static short p50[] = { //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x55, 0x55, 0x55, 0x55, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x55, 0x55, 0x55, 0x55, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x55, 0x55, 0x55, 0x55, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x55, 0x55, 0x55, 0x55, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x55, 0x55, 0x55, 0x55, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x55, 0x55, 0x55, 0x55, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x55, 0x55, 0x55, 0x55, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x55, 0x55, 0x55, 0x55, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x55, 0x55, 0x55, 0x55, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x55, 0x55, 0x55, 0x55, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x55, 0x55, 0x55, 0x55, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x55, 0x55, 0x55, 0x55, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x55, 0x55, 0x55, 0x55, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x55, 0x55, 0x55, 0x55, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x55, 0x55, 0x55, 0x55, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0x55, 0x55, 0x55, 0x55, //n
	};

	static short p75[] = { //n
			0xaa, 0xaa, 0xaa, 0xaa, 0xff, 0xff, 0xff, 0xff, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0xff, 0xff, 0xff, 0xff, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0xff, 0xff, 0xff, 0xff, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0xff, 0xff, 0xff, 0xff, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0xff, 0xff, 0xff, 0xff, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0xff, 0xff, 0xff, 0xff, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0xff, 0xff, 0xff, 0xff, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0xff, 0xff, 0xff, 0xff, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0xff, 0xff, 0xff, 0xff, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0xff, 0xff, 0xff, 0xff, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0xff, 0xff, 0xff, 0xff, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0xff, 0xff, 0xff, 0xff, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0xff, 0xff, 0xff, 0xff, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0xff, 0xff, 0xff, 0xff, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0xff, 0xff, 0xff, 0xff, //n
			0xaa, 0xaa, 0xaa, 0xaa, 0xff, 0xff, 0xff, 0xff, //n
	};

	private static void create_projection() {
		ffp.ffpMatrixMode(FFP_PROJECTION);
		ffp.ffpLoadIdentity();
		ffp.ffpOrtho(-1, 1, -1, 1, -1, 1);
		ffp.ffpMatrixMode(FFP_MODELVIEW);
	}

	@Override
	public void dbInit(int width, int height) {
		create_projection();

	}

	private float gamma = 1.0f;

	@Override
	public void dbUpdate() {
		if (keyPressed(KEY_R)) {
			gamma += 0.05f;
			ffp.ffpVideoPropertyf(FFP_VIDEO_GAMMA, gamma);
			if (gamma > 1.5f) {
				gamma = 1.5f;
			}
			System.out.println(gamma);
		}
		if (keyPressed(KEY_F)) {
			gamma -= 0.05f;
			ffp.ffpVideoPropertyf(FFP_VIDEO_GAMMA, gamma);
			if (gamma < 0.5f) {
				gamma = 0.5f;
			}
			System.out.println(gamma);
		}
	}

	@Override
	public void dbRender() {
		ffp.ffpClear(FFP_VIDEO_BUFFER);

		/** DITHERED ROW **/

		/* solid black */

		/* 25% white */
		ffp.ffpEnable(FFP_POLYGON_STIPPLE);
		ffp.ffpColor1f(1.0f);
		ffp.ffpPolygonStipple(p25);
		ffp.ffpRectf(-0.6f, 1.0f, -0.2f, 0.01f);

		/* 50% white */
		ffp.ffpPolygonStipple(p50);
		ffp.ffpRectf(-0.2f, 1.0f, 0.2f, 0.01f);

		/* 75% white */
		ffp.ffpPolygonStipple(p75);
		ffp.ffpRectf(0.2f, 1.0f, 0.6f, 0.01f);

		/* 100% white */
		ffp.ffpDisable(FFP_POLYGON_STIPPLE);
		ffp.ffpRectf(0.6f, 1.0f, 1.0f, 0.01f);

		/*** GRAY ROW ***/

		/* solid black */

		/* 25% white */
		ffp.ffpColor1f(0.25f);
		ffp.ffpRectf(-0.6f, -0.01f, -0.2f, -1.0f);

		/* 50% white */
		ffp.ffpColor1f(0.5f);
		ffp.ffpRectf(-0.2f, -0.01f, 0.2f, -1.0f);

		/* 75% white */
		ffp.ffpColor1f(0.75f);
		ffp.ffpRectf(0.2f, -0.01f, 0.6f, -1.0f);

		/* 100% white */
		ffp.ffpColor1f(1.0f);
		ffp.ffpRectf(0.6f, -0.01f, 1.0f, -1.0f);

		ffp.ffpFlush(FFP_MULTI_THREADED);
	}

}
